REM **********************************************
REM CURSOR CONTROL                        VE 01.02
REM DATE 11/2/84                     HARRY WATSON.
REM **********************************************


GOSUB 2000
GOSUB 3000

STOP


2000                                  REM THE FOLLOWING DEFINES CURSOR MOVEMENT

DEF FN.CHOME$ = CHR$(94)+CHR$(126):            		REM MOVE CURSOR TO COL 1, ROW 1
DEF FN.CLEAR$ = CHR$(27) + CHR$(91)+CHR$(50)+CHR$(74): REM CLEAR SCREEN, HOME CURSOR
DEF FN.CLEAR.RHT$=CHR$(27)+CHR$(91)+CHR$(75):		REM CLEAR LINE RIGHT OF CURSOR

DEF FN.CUP$ = CHR$(27) +CHR$(91)+CHR$(49)+CHR$(65):     REM CURSOR UP ONE ROW
DEF FN.CDOWN$ = CHR$(27)+CHR$(91)+CHR$(49)+CHR$(66):    REM CURSOR DOWN ONE ROW
DEF FN.CRHT$ = CHR$(27)+CHR$(91)+CHR$(49)+CHR$(67):     REM CURSOR RIGHT ONE SPACE
DEF FN.CLFT$ = CHR$(27)+CHR$(91)+CHR$(49)+CHR$(68):     REM CURSOR LEFT ONE SPACE

DIM UP$(26),RHT$(80),DOWN$(26),LFT$(80)

Z%=I%+48:					REM THE EXTRA VALUE REQUIRED FOR CURSOR
DEF FN.UP$(I%) = CHR$(27)+CHR$(91)+CHR$(Z%)+CHR$(65):   REM CURSOR UP I% ROWS
DEF FN.DOWN$(I%)=CHR$(27)+CHR$(91)+CHR$(Z%)+CHR$(66):   REM CURSOR DOWN I% ROWS
DEF FN.RHT$(I%)=CHR$(27)+CHR$(91)+CHR$(Z%)+CHR$(67):    REM CURSOR RIGHT I% SPACES
DEF FN.LFT$(I%)=CHR$(27)+CHR$(91)+CHR$(Z%)+CHR$(68):    REM CURSOR LEFT I% SPACES

DEF FN.GOFF$=CHR$(27)+CHR$(91)+CHR$(48)+CHR$(109):	REM ALL GRAPHICS FEATURES OFF
DEF FN.RVON$=CHR$(27)+CHR$(91)+CHR$(55)+CHR$(109):	REM REVERSE VIDEO ON

RETURN

  		
	REM *******************************************************
	REM DATE 11/5/84	              	    BY HARRY WATSON

	REM PRINT UTILITIES FOR THE EPSON PRINTER          VE 01.02
	REM *******************************************************
 3000
	PRINT FN.CLEAR$
	PRINT:PRINT:PRINT:PRINT:
	PRINT TAB(20);"PRINT UTILITIES FOR THE EPSON PRINTER":
	PRINT TAB(20);"~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~":
	PRINT
	PRINT TAB(10);"Please choose one of the options from the selection":
	PRINT:
	PRINT TAB(10);"0) NO MORE CHANGES/FINISHED":
	PRINT TAB(10);"1) SIZE OF CHARACTER":
	PRINT TAB(10);"2) LENGTH OF LINE":
	PRINT TAB(10);"3) LENGTH OF PAGE":
	PRINT TAB(10);"4) SPACING OF LINE":
	PRINT TAB(10);"5) PERFORATION SKIP":
	PRINT TAB(10);"6) PAPER DECTECTOR":

	PRINT TAB(10);"7) INITIALIZE PRINTER":
	PRINT

	PRINT TAB(10);
	INPUT "WHICH OPTION DO YOU WANT TO USE ? ";OPTION%


	REM ~~~~~~~~~~~~~~~~~~ WAIT FOR VALID OPTION ~~~~~~~~~~~~~~~~~~

	WHILE (OPTION% < 0 ) OR (OPTION% > 7)
		PRINT FN.CUP$; FN.CLEAR.RHT$; TAB(10);
		INPUT "ENTER AN OPTION BETWEEN 0 AND 7:  ";OPTION%
	WEND


	REM ~~~~~~~~~~~~~~ MAKE VALID PRINT SELECTION ~~~~~~~~~~~~~~~

	IF OPTION% NE 0 THEN \
		PRINT FN.CLEAR$

	ON OPTION% GOSUB 4000,			\ CHANGE SIZE OF PRINT
			 5000,			\ CHANGE LENGTH OF LINE
			 6000,			\ CHANGE LENGTH OF PAGE
			 7000,			\ CHANGE HOW MUCH EACH LINE MOVES
			 8000,			\ CHANGE PERFERATION SKIP
			 9000,			\ CHANGE PAPER DETECTION
			11000:			\ INITIALIZE PRINTER

	IF OPTION% = 0 THEN RETURN
	REM ~~~~~~~~~ 0 WAS ENTERED, END OF CHANGES ~~~~~~~~~~~~
	GOTO 3000



4000
	REM ~~~~~~~~ CHANGE SIZE OF PRINT ~~~~~~~~~~~~~


	PRINT  TAB(10);
	PRINT "PRINT SIZES ARE CHANGED IN THIS SECTION"
	PRINT
	PRINT TAB(10);"Please choose one of the options from the selection":
	PRINT:
	PRINT TAB(10);"0) NO MORE CHANGES/FINISHED":
	PRINT
	PRINT TAB (05);"+-------+-----------------------------+---------+":
	PRINT TAB (08);"ON";\
	TAB (46);"OFF"
	PRINT TAB (05);"+-------+-----------------------------+---------+":
	PRINT TAB(10);     "1)        INTERNATIONAL CHARACTERS  (11":
	PRINT TAB(10);     "2)        ENLARGED                  (12":
	PRINT TAB(10);     "3)        DOUBLE                    (13":
	PRINT TAB(10);     "4)        EMPHASIZED                (14":
	PRINT TAB(10);     "5)        CONDENSED  (15 CPS)       (15":
	PRINT TAB(10);     "6)        SUBSCRIPT                 (16":
	PRINT TAB(10);     "7)        SUPER-SUBSCRIPT           (17":
PRINT  TAB(10);     "8)        ELITE      (12 CPS)       (18":
PRINT  TAB(10);     "9)        ALTERNATE                 (19":
PRINT  TAB(9);     "10)        GRAPHICS                  (20":
	PRINT

	PRINT TAB(10);
	INPUT "WHICH OPTION DO YOU WANT TO USE ? ";OPTION%


	REM ~~~~~~~~~~~~~~~~~~ WAIT FOR VALID OPTION ~~~~~~~~~~~~~~~~~~

	WHILE (OPTION% < 0 ) OR (OPTION% > 20)
		PRINT FN.CUP$; FN.CLEAR.RHT$; TAB(10);
		INPUT "ENTER AN OPTION BETWEEN 0 AND 20: ";OPTION%
	WEND

	REM ~~~~~~~~~~~~~~ MAKE VALID PRINT SELECTION ~~~~~~~~~~~~~~~

	IF OPTION% NE 0 THEN \
		PRINT FN.CLEAR$


	ON OPTION% GOSUB 4100,			\ NORMAL ON
			 4200,			\ ENLARGED ON
			 4300,			\ DOUBLE ON
			 4400,			\ EMPHASIZED ON
			 4500,			\ CONDENSED ON (15 CPS)
			 4600,			\ SUBSCRIPT ON
			 4700, 			\ SUPER-SUBSCRIPT ON
4800, \ELITE (12 CPS)
4900, \ALTERNATE ON
4950, \GRAPHICS
	                4110,			\ NORMAL OFF
			 4210,			\ ENLARGED OFF
			 4310,			\ DOUBLE OFF
			 4410,			\ EMPHASIZED OFF
			 4510,			\ CONDENSED OFF
			 4610,			\ SUBSCRIPT OFF
			 4710,			\ SUPER-SUBSCRIPT OFF
4810, \ ELITE (12 CPS) OFF
4910, \ ALTERNATE OFF
4960: \ GRAPHICS OFF
RETURN		\	TO 3000
	REM ~~~~~~~~~ 0 WAS ENTERED, END OF CHANGES ~~~~~~~~~~~~


4100
4110
	REM ~~~~~~~~~ 1 WAS ENTERED, INTERNAT CHARACTERS  ~~~~~~
	PRINT TAB(10);
	PRINT:PRINT:PRINT
	PRINT TAB(10);
	PRINT "INTERNATIONAL CHARACTER SET"
	PRINT
	PRINT TAB(10);
	PRINT "NUMBER           		COUNTRY"
	PRINT TAB(10);
	PRINT "0)               		U.S.A."
	PRINT TAB(10);
	PRINT "1)               		France"
	PRINT TAB(10);
	PRINT "2)               		Germany"
	PRINT TAB(10);
	PRINT "3)               		England"
	PRINT TAB(10);
	PRINT "4)               		Denmark"
	PRINT TAB(10);
	PRINT "5)               		Sweden"
	PRINT TAB(10);
	PRINT "6)               		Italy"
	PRINT TAB(10);
	PRINT "7)               		Spain"
	PRINT TAB(10);
	INPUT "ENTER THE NUMBER REQUIRED ?";OPTION%


	REM ~~~~~~~~~~~~~~~~~~ WAIT FOR VALID OPTION ~~~~~~~~~~~~~~~~~~

	WHILE (OPTION% < 0 ) OR (OPTION% >  7)
		PRINT FN.CUP$; FN.CLEAR.RHT$; TAB(10);
		INPUT "ENTER AN VALUE BETWEEN 0 AND 7:  ";OPTION%
	WEND

	REM ~~~~~~~~~~~~~~ MAKE VALID PRINT SELECTION ~~~~~~~~~~~~~~~

	IF OPTION% NE 0 THEN \
		PRINT FN.CLEAR$
	LPRINTER
	PRINT CHR$(27);"R";CHR$(OPTION%);
	PRINT ".";
	CONSOLE
RETURN		\	TO 3000


4200
	REM ~~~~~~~~~ 2 WAS ENTERED, ENLARGED PRINT   ~~~~~~~~~~

	LPRINTER
	PRINT CHR$(27);"W";CHR$(1);
	PRINT ".";
	CONSOLE
RETURN		\	TO 3000


4210
	REM ~~~~~~~~~ 9  WAS ENTERED, ENLARGED PRINT OFF ~~~~~~~

	LPRINTER
	PRINT CHR$(27);"W";CHR$(0);
	PRINT ".";
	CONSOLE
RETURN		\	TO 3000


4300
	REM ~~~~~~~~~ 3 WAS ENTERED, DOUBLE PRINT     ~~~~~~~~~~

	LPRINTER
	PRINT CHR$(27);"G";
	PRINT ".";
	CONSOLE
RETURN		\	TO 3000


4310
	REM ~~~~~~~~~ 10 WAS ENTERED, DOUBLE PRINT OFF ~~~~~~~~~

	LPRINTER
	PRINT CHR$(27);"H";
	PRINT ".";
	CONSOLE
RETURN		\	TO 3000


4400
	REM ~~~~~~~~~ 4 WAS ENTERED, EMPHASIZED PRINT ~~~~~~~~~~

	LPRINTER
	PRINT CHR$(27);"E";
	PRINT ".";
	CONSOLE
RETURN		\	TO 3000


4410
	REM ~~~~~~~~~ 11 WAS ENTERED, EMPHASIZED PRINT OFF ~~~~~~

	LPRINTER
	PRINT CHR$(27);"F";
	PRINT ".";
	CONSOLE
RETURN		\	TO 3000


4500
	REM ~~~~~~~~~ 5 WAS ENTERED, CONDENSED PRINT  ~~~~~~~~~~

	LPRINTER
	PRINT CHR$(15);
	PRINT ".";
	CONSOLE
RETURN		\	TO 3000


4510
	REM ~~~~~~~~~ 12 WAS ENTERED, CONDENSED PRINT OFF ~~~~~~~

	LPRINTER
	PRINT CHR$(18);
	PRINT ".";
	CONSOLE
RETURN		\	TO 3000


4600
	REM ~~~~~~~~~ 6 WAS ENTERED, SUBSCRIPT PRINT  ~~~~~~~~~~

	LPRINTER
	PRINT CHR$(27);"S";
	PRINT ".";
	CONSOLE
RETURN		\	TO 3000


4610
	REM ~~~~~~~~~ 13 WAS ENTERED, SUBSCRIPT PRINT OFF ~~~~~~~

	LPRINTER
	PRINT CHR$(27);"T";CHR$(27);"H";
	PRINT ".";
	CONSOLE
RETURN		\	TO 3000


4700
	REM ~~~~~~~~~ 7 WAS ENTERED, SUPER-SUBSCRIPT PRINT  ~~~~

	LPRINTER
	PRINT CHR$(15);
	PRINT CHR$(27);"S";
	PRINT ".";
	CONSOLE
RETURN		\	TO 3000

4710
	REM ~~~~~~~~~ 14 WAS ENTERED, SUPER-SUBSCRIPT PRINT  OFF ~~~~~~

	LPRINTER
	PRINT CHR$(18);
	PRINT CHR$(27);"T";CHR$(27);"H";
	PRINT ".";
	CONSOLE
RETURN		\	TO 3000


4800
	REM ~~~~~~~~~ 8 WAS ENTERED, ELITE PRINT  ~~~~~~~~~~

	LPRINTER
	PRINT CHR$(27);"M";
	PRINT ".";
	CONSOLE
RETURN		\	TO 3000


4810
	REM ~~~~~~~~~ 17 WAS ENTERED, ELITE PRINT  OFF~~~~~~~~~~

	LPRINTER
	PRINT CHR$(27);"P";
	PRINT ".";
	CONSOLE
RETURN		\	TO 3000

4900
	REM ~~~~~~~~~ 9 WAS ENTERED, ALTERNATE PRINT  ON ~~~~~~~~~~

	LPRINTER
	PRINT CHR$(27);"4";
	PRINT ".";
	CONSOLE
RETURN		\	TO 3000

4910
	REM ~~~~~~~~~ 18 WAS ENTERED, ALTERNATE PRINT  OFF ~~~~~~~~~~

	LPRINTER
	PRINT CHR$(27);"5";
	PRINT ".";
	CONSOLE
RETURN		\	TO 3000

4950
	REM ~~~~~~~~~ 10 WAS ENTERED, GRAPHICS PRINT  ON~~~~~~~~~~

	LPRINTER
	PRINT CHR$(27);"m";CHR$(4)
	PRINT ".";
	CONSOLE
RETURN		\	TO 3000

4960
	REM ~~~~~~~~~ 20 WAS ENTERED, GRAPHICS PRINT  OFF ~~~~~~~~~~

	LPRINTER
	PRINT CHR$(27);"m";CHR$(0)
	PRINT ".";
	CONSOLE
RETURN		\	TO 3000

5000
	REM ~~~~~~~~~~ CHANGE LENGTH OF LINE ~~~~~~~~~~~~~
	PRINT TAB(10);
	PRINT "THE WIDTH OF THE PRINTED PAGE IS ESTABLISHED IN THIS SECTION."
	PRINT:PRINT
	PRINT TAB(10);
	PRINT "Please NOTE on standard print (133) is the maximum."
	PRINT TAB(10);
	PRINT "              condensed print (233) is the maximum."
	PRINT TAB(10);
	PRINT "               enlarged print ( 68) is the maximum."
	PRINT TAB(10);
	PRINT "     enlarged condensed print (116) is the maximum."
	PRINT:PRINT:PRINT:
	PRINT TAB(10);
	INPUT "ENTER THE WIDTH REQUIRED";WIDTH%
	LPRINTER
	PRINT CHR$(27);"Q";CHR$(WIDTH%);
	PRINT ".";
	CONSOLE
RETURN		\	GOTO 3000


6000
	REM ~~~~~~~~~~~~~~~~ CHANGE LENGTH OF PAGE ~~~~~~~~~~~~~~~~~~
	PRINT TAB(10);
	PRINT "THE LENGTH OF THE PAGE IS ESTABLISHED IN THIS SECTION."
	PRINT:PRINT
	PRINT TAB(10);
	PRINT "Please NOTE on standard paper ( 66) is the standard."
	PRINT TAB(10);
	PRINT "There are two ways to set up the page length,"
	PRINT TAB(10);
	PRINT "		1, by the length of the paper in inches."

	PRINT TAB(10);
	PRINT "		2, by the number of lines on the page."
	PRINT TAB(10);
	INPUT "WHICH OF THESE DO YOU WANT ? ";OPTION%


	REM ~~~~~~~~~~~~~~~~~~ WAIT FOR VALID OPTION ~~~~~~~~~~~~~~~~~~

	WHILE (OPTION% < 1 ) OR (OPTION% >  2)
		PRINT FN.CUP$; FN.CLEAR.RHT$; TAB(10);
		INPUT "ENTER AN OPTION BETWEEN 1 AND 2:  ";OPTION%
	WEND


	REM ~~~~~~~~~~~~~~ MAKE VALID PRINT SELECTION ~~~~~~~~~~~~~~~

	IF OPTION% NE 0 THEN \
		PRINT FN.CLEAR$


	ON OPTION% GOSUB 6100,			\ LENGTH OF PAGE IN INCHES
			 6200:


RETURN		\	GOTO 3000


6100
	REM ~~~~~~~ 1 WAS ENTERED LENGTH OF PAGE IN INCHES ~~~~~~~~~~~
	PRINT TAB(10);
	PRINT:PRINT:PRINT
	PRINT TAB(10);
	PRINT "THE LENGTH WILL BE ENTERED IN INCHES FOR THE PAGE"
	PRINT
	PRINT TAB(10);
	PRINT "The MAXIMUM possible is 22 inches"
	PRINT TAB(10);
	INPUT "ENTER THE LENGTH REQUIRED ?";OPTION%


	REM ~~~~~~~~~~~~~~~~~~ WAIT FOR VALID OPTION ~~~~~~~~~~~~~~~~~~

	WHILE (OPTION% < 1 ) OR (OPTION% >  22)
		PRINT FN.CUP$; FN.CLEAR.RHT$; TAB(10);
		INPUT "ENTER AN VALUE BETWEEN 1 AND 22: ";OPTION%
	WEND


	REM ~~~~~~~~~~~~~~ MAKE VALID PRINT SELECTION ~~~~~~~~~~~~~~~

	IF OPTION% NE 0 THEN \
		PRINT FN.CLEAR$
	LPRINTER
	PRINT CHR$(27);"C";CHR$(0);CHR$(OPTION%);
	PRINT ".";
	CONSOLE
RETURN		\	TO 3000



6200
	REM ~~~~~~~ 2 WAS ENTERED LENGTH OF PAGE IN LINES  ~~~~~~~~~~~
	PRINT TAB(10);
	PRINT:PRINT:PRINT
	PRINT TAB(10);
	PRINT "THE LENGTH WILL BE ENTERED IN LINES FOR THE PAGE"
	PRINT
	PRINT TAB(10);
	PRINT "The MAXIMUM possible is 127 lines"
	PRINT TAB(10);
	INPUT "ENTER THE LENGTH REQUIRED ?";OPTION%


	REM ~~~~~~~~~~~~~~~~~~ WAIT FOR VALID OPTION ~~~~~~~~~~~~~~~~~~

	WHILE (OPTION% < 1 ) OR (OPTION% >  127)
		PRINT FN.CUP$; FN.CLEAR.RHT$; TAB(10);
		INPUT "ENTER AN VALUE BETWEEN 1 AND 127:";OPTION%
	WEND


	REM ~~~~~~~~~~~~~~ MAKE VALID PRINT SELECTION ~~~~~~~~~~~~~~~

	IF OPTION% NE 0 THEN \
		PRINT FN.CLEAR$
	LPRINTER
	PRINT CHR$(27);"C";CHR$(OPTION%);
	PRINT ".";
	CONSOLE
RETURN		\	TO 3000

7000
	REM ~~~~~~~~~~~~  CHANGE LINE SPACING ~~~~~~~~~~~~~~~~~~~~~~
	PRINT TAB(10);
	PRINT "THE LINE SPACING IS ESTABLISHED IN THIS SECTION."
	PRINT:PRINT:
	PRINT TAB(10);
	PRINT "The standard line space is 1/8 of an inch."

	PRINT TAB(10);
	PRINT "Through the use of this section it is possible to pitch"
	PRINT TAB(10);
	PRINT "the line spacing in units of n/216 inches."
	PRINT TAB(10);
	INPUT "ENTER THE PITCH REQUIRED ?";OPTION%


	REM ~~~~~~~~~~~~~~~~~~ WAIT FOR VALID OPTION ~~~~~~~~~~~~~~~~~~

	WHILE (OPTION% < 1 ) OR (OPTION% >  216)
		PRINT FN.CUP$; FN.CLEAR.RHT$; TAB (10);
		INPUT "ENTER AN VALUE BETWEEN 1 AND 216:";OPTION%
	WEND


	REM ~~~~~~~~~~~~~~ MAKE VALID PRINT SELECTION ~~~~~~~~~~~~~~~

	IF OPTION% NE 0 THEN \
		PRINT FN.CLEAR$
	LPRINTER
	PRINT CHR$(27);"3";CHR$(OPTION%);
	PRINT ".";
	CONSOLE
RETURN		\	TO 3000

8000

	REM ~~~~~~~~~~~~  CHANGE PERFERATION SKIP  ~~~~~~~~~~~~~~~~~
	PRINT TAB(10);
	PRINT "THE PERFERATION SPACING IS ESTABLISHED IN THIS SECTION."
	PRINT:PRINT:
	PRINT TAB(10);
	PRINT "The standard depends on the DIP switch pin 2-4."
	PRINT TAB(10);
	PRINT "If the switch is set ON then skip over perforation will "
	PRINT TAB(10);
	PRINT "always be 1 inch and this section will have no effect."

	PRINT TAB(10);
	PRINT "Through the use of this section it is possible to pitch"
	PRINT TAB(10);
	PRINT "the skip over in units of printed lines."
	PRINT TAB(10);
	PRINT "If NO skip over is required enter (0) ."
	PRINT TAB(10);
	INPUT "ENTER THE PITCH REQUIRED ?";OPTION%


	REM ~~~~~~~~~~~~~~~~~~ WAIT FOR VALID OPTION ~~~~~~~~~~~~~~~~~~

	WHILE (OPTION% < 0 ) OR (OPTION% >  127)
		PRINT FN.CUP$; FN.CLEAR.RHT$; TAB (10);
		INPUT "ENTER AN VALUE BETWEEN 0 AND 127:";OPTION%
	WEND


	REM ~~~~~~~~~~~~~~ MAKE VALID PRINT SELECTION ~~~~~~~~~~~~~~~
		PRINT FN.CLEAR$
	LPRINTER

	IF OPTION% = 0 THEN \
	PRINT CHR$(27);"O";
	IF OPTION% NE 0 THEN \
	PRINT CHR$(27);"N";CHR$(OPTION%);
	PRINT ".";
	CONSOLE
RETURN		\	TO 3000

9000

	REM ~~~~~~~~~~~~  CHANGE PAPER DETECTION  ~~~~~~~~~~~~~~~~~~~
	PRINT TAB(10);
	PRINT "THE PAPER END DETECTION IS ESTABLISHED IN THIS SECTION."
	PRINT:PRINT:
	PRINT TAB(10);
	PRINT "The standard depends on the DIP switch pin 1-6."
	PRINT TAB(10);
	PRINT "1) will request PAPER END ON."

	PRINT TAB(10);
	PRINT "2) will request PAPER END OFF."
	PRINT TAB(10);
	INPUT "ENTER THE STATE REQUIRED ?";OPTION%


	REM ~~~~~~~~~~~~~~~~~~ WAIT FOR VALID OPTION ~~~~~~~~~~~~~~~~~~

	WHILE (OPTION% < 1 ) OR (OPTION% >  2)
		PRINT FN.CUP$; FN.CLEAR.RHT$; TAB (10);
		INPUT "ENTER AN VALUE BETWEEN 1 AND 2:";OPTION%
	WEND
	REM ~~~~~~~~~~~~~~ MAKE VALID PRINT SELECTION ~~~~~~~~~~~~~~~
		PRINT FN.CLEAR$
	LPRINTER

	IF OPTION% = 1 THEN \
	PRINT CHR$(27);"9";
	IF OPTION% NE 0 THEN \
	PRINT CHR$(27);"8";
	PRINT ".";
	CONSOLE
RETURN		\	TO 3000

11000
	REM ~~~~~~~~~ 7 WAS ENTERED, INITIALIZE PRINTER ~~~~~~~~
	LPRINTER
	PRINT CHR$(27);"@";
	PRINT ".";
	CONSOLE
RETURN		\	TO 3000
END
