r


Key <ENTER> to continue: 

[74736,375]
ASYCHG.INC     26-May-85 2610         Accesses: 63

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: 

[70126,1110]
ASYNC.FIX      17-Apr-85 1235         Accesses: 82

    Keywords: ASYNC INTERRUPTS INTERRUPT SERVICE ROUTINE UART COMMUNICAT
IONS
    
    Describes a problem with the 11/84 version of Michael Quinlan's ASYN
C.INC
    (current version includes this fix).  Procedure Async_Close previous
ly
    would not properly close the communications port.  Scott Herr
    
    

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: r
The following is a fix for a problem that exists in Michael Quinlan's
(74736,375) ASYNC.INC:



Simply add the following line:

     Async_Open_Flag := true;

in function Async_Open right before:

     Async_Open := TRUE



Otherwise Async_Open_Flag is not properly updated and this may cause you
r
program to improperly close the communications port when Async_Open_Flag
is checked in procedure Async_Close.

Without this fix it is possible for the interrupt vectors to the interru
pt
service routine to remain as they were set up in function Async_Open.
This will allow communcations port interrupts to continue to jump
to your no longer existent interrupt service routine once your program
terminates.  This can cause some really weird problems like your program
bombing only when the phone rings because your modem sends RING to the
computer, computer jumps to no longer existent service routine, computer
bombs and you say WHAT? (or something more violent).

By the way, this same thing can happen for any program that includes the
interrupt handlers in its own code if it terminates abnormally for any
reason and doesn't get rid of the interrupt vector.


Scott Herr (70126,1110)
April 17, 1985


Key <ENTER> to continue: 

[70126,1110]
ASYNC.FIX      17-Apr-85 1235         Accesses: 82

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: 

[72105,1744]
ASYNC.INC      21-May-85 15575        Accesses: 121

    Keywords: IBM ASYNC PCJR INTERRUPT COM
    
    This version of Michael Quinlan's ASYNC.INC has been upgraded to be
    compatible with the PCjr; it now functions correctly with all member
s of
    the IBM PC line. It gives interrupt-driven buffered communication
    capabilities to Turbo programs for the IBM PC.  It is heavily depend
ent on
    that hardware.
    
    

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: 

[76703,755]
ATRIB.PAS      12-Jan-85 3730         Accesses: 163

    Keywords: MS-DOS FILE ATTRIBUTE MODIFIER
    
    Changes files attributes under MS-, PC-DOS.  File attributes include
 read
    only, system, hidden, archived, directory, and volume name.  The las
t two
    cannot be changed with this program.
    
    

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: 

[71016,1573]
BASCNV.PAS     03-Feb-85 2525         Accesses: 137

    Keywords: TURBO PASCAL BASIC REAL FLOATING POINT CONVERT CONVERSION
    
    Four procedures that convert between Turbo Pascal and MicroSoft BASI
C real
    formats.  Has only been tested with IBM BASICA, but it should work w
ith all
    versions of MS-BASIC, GW-BASIC, MBASIC or whatever.  This allows you
 to
    read BASIC files which have real or double numbers written with MKS$
 or
    MKD$.
      -  Bela Lubkin
    
    

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: 

[75755,573]
BASRTN.DOC     12-Jan-85 8670         Accesses: 156

    Keywords: BIOS ROM LOCATIONS MACHINE ACCESS SYSTEM STATUS
    
    this list of memory locations and status flags was originally compil
ed by
    Don Watkins 76003,252 from the IBM SIG to assist Basic programmers w
ho
    needed to access the machine more directly. i am uploading it here t
o
    assist turbo programmers who can convert this stuff over to turbo an
d do
    the same thing. it doesn't take alot of effort and may prove to be a
 useful
    exercise. see KEYSTAT.PAS for an example of  reading the keyboard st
atus
    byte(s) from turbo.   ------turbo uber alles------
    
    

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: 

[70206,174]
BBSINF.LBR     23-Mar-85 32865        Accesses: 149

    Keywords: VANCOUVER TURBO BBS 1.05 ASCII SUPPORT FILE LIBRARY
    
    The library of support files for the TurboBBS version 1.05. This inc
ludes
    welcome, bulletins, menus and help files. This (and the source file
    TURBBS.LBR) are binary files. No other files besides this and TURBBS
.LBR
    are required to operate the BBS. This file is named BBSINFO.LBR as f
ar as
    the BBS source expects.
    
    

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: 

[71016,1573]
BIGBRD.DOC     26-Jan-85 865          Accesses: 26

    Keywords: 8 BIT TURBO TOOLBOX GINST PROBLEM WITH THE BIG BOARD AND X
EROX
    820
    
    The GINST program does not run on the 'big board' CP/M system becaus
e of a
    design flaw in it's ROMs.  This file tells how to buy corrected ROMs
 for
    those machines.
    
    

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: 

[74766,416]
BIOS.LBR       03-Feb-85 25380        Accesses: 90

    Keywords: BIOS CPM FIX WORKAROUND
    
    Replacement procedures/functions to circumvent shortcomings of the B
orland
    BIOS procedures/functions.  CP/M specific.  Contains one squeezed .D
OC
    file. See SQLBR.DOC in DL 0 for help de-librarying this file and
    unsqueezing BIOS.DQC which is a member of this library file.
    
    

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: 

[70327,741]
BITS.MOD       07-May-85 640          Accesses: 110

    Keywords: BITACCESS TEST SET CLEAR SINGLE ONE BIT ACCESS MODIFICATIO
N
    MANIPULATION
    
    Procedures to test, set, and clear a single bit.
    
    

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: r



Key <ENTER> to continue: 

[70327,741]
BITS.MOD       07-May-85 640          Accesses: 110

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: 

[75206,1117]
BORDER.PAS     14-Mar-85 3055         Accesses: 75

    Keywords: IBM PC-DOS BORDER COLOR SET CHOOSE INLINE MACHINE ASSEMBLY
    
    This file contains an INLINE assembly language routine to allow the 
Turbo
    Pascal programmer to select the desired border color in conjunction 
with
    the color display.  A sample program is included for demonstration. 
 See
    also SETBDR.PAS
    
    

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: r


Key <ENTER> to continue: 

[75206,1117]
BORDER.PAS     14-Mar-85 3055         Accesses: 75

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: 

[71256,402]
BOX.PAS        23-Dec-84 3330         Accesses: 267

    Keywords: TURBO PASCAL DRAW BOX MENU
    
    
    
    

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: r



Key <ENTER> to continue: 

[71256,402]
BOX.PAS        23-Dec-84 3330         Accesses: 267

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: 

[71106,177]
BROWSE.TUR     15-Feb-85 13565        Accesses: 43

    Keywords: CIPHER CRYPTOGRAPHY
    
    
            Given the key, this program displays a file enciphered by
    ENCIPH.TUR. It only prints the result upon the console; it does NOT 
update
    the file.
    
    

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: 

[70100,271]
CACH22.PAS     24-Apr-85 5520         Accesses: 35

    Keywords: CACH22.PAS #3.02 85-04-24 CPM80 TURBO PASCAL 3.0 MEMORY SI
ZING
    DEMONSTRATION
    
    
     CACH22, when compiled and operated as a COM file, will take as litt
le
    space as possible for its loaded image, but it will then correctly a
cquire
    the rest of the CURRENTLY-AVAILABLE TPA for use in dynamic allocatio
n of
    stack, buffers, and so on.
     Version #3.02: Prevents GetMem from ignoring change to HeapPtr by u
sing
    the  built-in Release procedure to force change of heap location.
    
    

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: 

[75776,2075]
CASTIM.PAS     19-May-85 5820         Accesses: 35

    Keywords: CASSETTE TIME
    
    This program calculates the amount of time remaining on an audio cas
sette
    
    

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: 

[76703,755]
CHOUT          14-Nov-84 1680         Accesses: 150

    Keywords: CHANGE SWITCH OUTPUT PRINTER DRIVER
    
    Two ways to route output to the printer without having a logical dev
ice or
    file name as the first parameter of your write or writeln statements
.  One
    makes the LST device act like the CON device.  The other is a user w
ritten
    I/O driver written for MS-DOS or PC-DOS.
    
    

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: 

[71106,177]
CIPHER.TUR     15-Feb-85 6530         Accesses: 64

    Keywords: CIPHER CRYPTOGRAPHY
    
    
            This program enciphers/deciphers the printing characters in 
a file.
    For each printing character a new substitution cipher is generated. 
 A
    thirty character key governs the generation of the substitution ciph
ers. On
    a Zenith Z-100 (8088 @ 5 MHz), this program enciphers 70 characters/
second
    and deciphers 65 characters/second.  It should be quite secure.
    
    

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: r


Key <ENTER> to continue: 

[71106,177]
CIPHER.TUR     15-Feb-85 6530         Accesses: 64

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: 

[70120,174]
CIRCLE.PAS     12-Dec-84 475          Accesses: 144

    Keywords: ZENITH Z100 GRAPHICS DEMO
    
    This is a simple program demonstrating use of "GLIB.PAS".  It draws
    multiple concentric circles of different colors.
    
    

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: 

[75755,573]
CISBIN.PAS     08-Jan-85 6055         Accesses: 185

    Keywords: PROTOCOL CONVERTER TURBO COMPUSERVE A PROTOCOL UTILITY
    
    This program will convert compuserve BIN files to com files when dow
nloaded
    with a normal ascii <R> download. Files can also be converted from .
COM to
    BIN for upload.
    
    

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: t

DL 1 - Turbo Pascal : 

1 (DES) Description of Data Library
2 (BRO) Browse thru files
3 (DIR) Directory of files
4 (UPL) Upload a new file
5 (DOW) Download a file
6 (DL)  Change Data Library
7 (T)   Return to Function Menu 
8 (I)   Instructions

Enter selection or H for help: bro *.asm

[72435,1617]
STDOUT.ASM     29-Jan-85 430          Accesses: 91

    Keywords: REDIRECTION DOS TD OUTPUT TURBO
    
    Source to a standard output file used by TD.COM
    
    

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: 

[71016,1573]
TBOBIT.ASM     26-Jan-85 27125        Accesses: 23

    Keywords: TURBO PASCAL GRAPHICS FOR SANYO 550 SERIES
    
    A resident program for the Sanyo 550 series that allows Turbo full a
ccess
    to the Sanyo's graphics capabilities.  Can also be used to implement
    Turbo's own Plot and Draw procedures.  Full name is TURBOBIT.ASM.  S
ee also
    TBOBIT.COM, VIDIO.*, DEMBIT.PAS.
      By John Cooper
    
    

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: 

[74775,756]
TURRUN.ASM     18-Mar-85 15920        Accesses: 200

    Keywords: TURRUN TURBORUN CHILD PROCESS
    
    This the long awaited update of Turborun v1.0B The problem with memo
ry
    allocation has been fixed and the RetCode finally matches the documa
ntation
    (I hope).  It is known to work with 1-2-3 and Dbase III.  Thanks to 
John
    Falconer for prompting (and coding) this revision.
    
    

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: 

[72435,1617]
USEENV.ASM     29-Jan-85 27330        Accesses: 85

    Keywords: ENVIRONMENT DOS PC MS BATCH TD PROCESS VARIABLES
    
    Source code (MASM) for USEENV.COM.  (See description there)
    
    

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: 

[71016,1573]
VIDIO.ASM      26-Jan-85 490          Accesses: 27

    Keywords: TURBO PASCAL GRAPHICS FOR SANYO 550 SERIES
    
    A procedure to interface with TURBOBIT.ASM (TBOBIT.ASM) for sophisti
cated
    graphics text applications.  Full name is VIDEOIO.ASM.  See also VID
IO.COM,
    TBOBIT.*, DEMBIT.PAS.
      By John Cooper 74775,756
    
    

Disposition:

1 (R)    Read this file
2 (D)    Download this file
3 (T)    Top Data Library Menu

Key digit or ENTER for next: 

DL 1 - Turbo Pascal : 

1 (DES) Description of Data Library
2 (BRO) Browse thru files
3 (DIR) Directory of files
4 (UPL) Upload a new file
5 (DOW) Download a file
6 (DL)  Change Data Library
7 (T)   Return to Function Menu 
8 (I)   Instructions

Enter selection or H for help: t


Borland Int. Forum

Function Menu
1 (L)  Leave a Message
2 (R)  Read Messages
3 (CO) Conference Mode
4 (DL) Data Library (Former XA)
5 (B)  Bulletins
6 (V)  View Member Directory
7 (SS) Set Sub-topic
8 (OP) Set User Options
9 (I)  Instructions
0 (E)  Exit from Borland Int. Forum

Enter selection or H for help: 
