
Type
  MG_TimeStr = String[10];

Function CurrentTime : MG_TimeStr;
{** Returns the current time in '99:99:99 am/pm' format **}
Type
  RegPack = Record
            AX,BX,CX,DX,BP,SI,DI,DS,ES,Flags : Integer;
            End;
Const
  Am = 'am';
  Pm = 'pm';

Var
  Registers      : RegPack;
  Hour,Min,Sec   : Integer;
  HStr,MStr,Sstr : String[2];
  AmPm           : String[2];

Begin
With Registers do
  AX := $2C shl 8;
MSDos(Registers);
With Registers do
  Begin
  Hour := Hi(CX);
  AmPm := Am;
  If Hour = 0 then
    Begin
    Hour := 12;
    AmPm := Pm;
    End;
  If Hour > 12 then
    Begin
    Hour := Hour - 12;
    AmPm := Pm;
    End;
  Min  := Lo(CX);
  Sec  := Hi(DX);
  Str(Hour:2,HStr);
  If HStr[1] = ' ' then
    HStr[1] := '0';
  Str(Min:2,MStr);
  If MStr[1] = ' ' then
    MStr[1] := '0';
  Str(Sec:2,SStr);
  If SStr[1] = ' ' then
    SStr[1] := '0';
  End;
CurrentTime := Concat(HStr,':',mStr,':',SStr,AmPm);
End; {CurrentTime}