{ CDS-ATTR.INC  Video attribute control routines system. }


const  REVERSE_VID : Byte = $1F;  { Reverse video attribute }
                                  { Intense White on Blue }
       BRIGHT_VID  : Byte = $70;  { Normal video attribute }
                                  { Black on Grey. }
       DIM_VID     : Byte = $71;  { Low video attribute }
                                  { Blue on Grey. }
       BLINK_VID   : Byte = $F1;  { Blinking Video attribute }
                                  { Blinking Blue on Grey. }
       BLINK_FGND  : Byte = $1F;

       NORM_BGND   : Integer = WHITE;
       REV_BGND    : Integer = BLUE;
       NORM_FGND   : Integer = BLACK;
       DIM_FGND    : Integer = BLUE;
       BORDER      : Integer = CYAN;

       SCR_EXT     : string[4] = '.TSC'; { File exetension for color screens.}

var    first_var : Integer;  { Marks start of global variables. }
       vid_attr  : Byte;

  procedure Norm_Video;
    begin
      vid_attr := BRIGHT_VID;
      TextColor(NORM_FGND); TextBackground(NORM_BGND);
    end; { Norm_Video }

  procedure Low_Video;
    begin
      vid_attr := DIM_VID;
      TextColor(DIM_FGND); TextBackground(NORM_BGND);
    end; { Low_Video }

  procedure Blink_Video;
    begin
      vid_attr := BLINK_VID;
      TextColor(BLINK_FGND); TextBackground(REV_BGND);
    end { Blink_Video };

  procedure Rev_Video;
    begin
      vid_attr := REVERSE_VID;
      TextColor(NORM_BGND); TextBackground(REV_BGND);
    end { Rev_Video };

  function  Mono_Monitor: Boolean;
    var  video_type : Byte;

    begin
      video_type := (Mem[$0000:$0410] and $30);
      case video_type of
        $20 : Mono_Monitor := FALSE;
        $30 : Mono_Monitor := TRUE;
        else  begin
                WriteLn(#7);
              end;
     end; {case}
    end; { Mono_Monitor }
